package enseirb.myinpulse.model;

import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@Entity
@Table(name = "section_cell")
public class SectionCell {

    @Id
    @NotNull
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long idSectionCell;

    @Column(length = 255)
    private String title;

    private String contentSectionCell;

    private LocalDateTime modificationDate;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "idProject")
    private Project projectSectionCell;

    /*@ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "idAdministrator")
    private Administrator administratorSectionCell;*/
    // should now be useless

    @ManyToMany(mappedBy = "listSectionCell")
    private List<Appointment> appointment = new ArrayList<>();

    @OneToMany(mappedBy = "sectionCellAnnotation", fetch = FetchType.LAZY, orphanRemoval = true)
    private List<Annotation> listAnnotation = new ArrayList<>();

    public SectionCell() {}

    public SectionCell(
            Long idSectionCell,
            String title,
            String contentSectionCell,
            LocalDateTime modificationDate) {
        this.idSectionCell = idSectionCell;
        this.title = title;
        this.contentSectionCell = contentSectionCell;
        this.modificationDate = modificationDate;
    }

    public Long getIdSectionCell() {
        return idSectionCell;
    }

    public void setIdSectionCell(Long idSectionCell) {
        this.idSectionCell = idSectionCell;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContentSectionCell() {
        return contentSectionCell;
    }

    public void setContentSectionCell(String contentSectionCell) {
        this.contentSectionCell = contentSectionCell;
    }

    public LocalDateTime getModificationDate() {
        return modificationDate;
    }

    public void setModificationDate(LocalDateTime modificationDate) {
        this.modificationDate = modificationDate;
    }
}
