package enseirb.myinpulse.service.database.old_controllers_to_convert_to_services;

import enseirb.myinpulse.model.SectionCell;
import enseirb.myinpulse.repository.SectionCellRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

import java.time.LocalDateTime;
import java.util.Optional;

@RestController
public class SectionCellController {

    @Autowired SectionCellRepository sectionCellRepository;

    @GetMapping("/SectionCell")
    @ResponseBody
    public Iterable<SectionCell> allSectionCells() {
        return this.sectionCellRepository.findAll();
    }

    @GetMapping("/SectionCell/{id}")
    public SectionCell getSectionCellById(@PathVariable Long id) {
        Optional<SectionCell> sectionCell = this.sectionCellRepository.findById(id);
        if (sectionCell.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cette cellule de section n'existe pas");
        }
        return sectionCell.get();
    }

    @PostMapping("/SectionCell")
    public SectionCell addSectionCell(@RequestBody SectionCell sectionCell) {
        return this.sectionCellRepository.save(sectionCell);
    }

    @PostMapping("/SectionCell/{id}")
    public SectionCell updateSectionCell(
            @PathVariable Long id,
            String title,
            String contentSectionCell,
            LocalDateTime modificationDate) {
        Optional<SectionCell> sectionCell = this.sectionCellRepository.findById(id);
        if (sectionCell.isEmpty()) {
            throw new ResponseStatusException(
                    HttpStatus.NOT_FOUND, "Cette cellule de section n'existe pas");
        }
        if (title != null) {
            sectionCell.get().setTitle(title);
        }
        if (contentSectionCell != null) {
            sectionCell.get().setContentSectionCell(contentSectionCell);
        }
        if (modificationDate != null) {
            sectionCell.get().setModificationDate(modificationDate);
        }
        return this.sectionCellRepository.save(sectionCell.get());
    }
}
